// Direct3DIM.cpp: CDirect3DIM NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Direct3DIM.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CDirect3DIM::CDirect3DIM()
{
	m_bInit = false;
	m_pDirect3D = NULL;
	m_pDirect3DDevice = NULL;
}

CDirect3DIM::~CDirect3DIM()
{
	ReleaseAll();
}

void CDirect3DIM::ReleaseAll()
{
	if( m_pDirect3DDevice != NULL )
	{
		m_pDirect3DDevice->Release();
		m_pDirect3DDevice = NULL;
	}
	if( m_pDirect3D != NULL )
	{
		m_pDirect3D->Release();
		m_pDirect3D = NULL;
	}
}

bool CDirect3DIM::Initialize(CDirectDraw *pDD, CDirectDrawSurface *pBack)
{
	HRESULT hr;
	hr = pDD->m_pDirectDraw->QueryInterface( IID_IDirect3D3, (void**)&m_pDirect3D );
	if( hr!=D3D_OK )
		return false;

	memset( &m_DevInfo , 0 , sizeof(m_DevInfo) );
	m_DevInfo.cm = D3DCOLOR_RGB;	// ftHgłRGBf
	hr = m_pDirect3D->EnumDevices(D3DEnumDeviceCallBack, &m_DevInfo);
	if( hr!=D3D_OK )
		return false;

	if( m_DevInfo.bHard )
		hr = m_pDirect3D->CreateDevice(*(m_DevInfo.pGuid),pBack->m_pSurface, &m_pDirect3DDevice,NULL);
	else
	{
		if( D3D_OK != m_pDirect3D->CreateDevice(IID_IDirect3DMMXDevice,
								pBack->m_pSurface, &m_pDirect3DDevice,NULL) )
		{
			// MMX łȂ
			//RGB
//			hr = m_pDirect3D->CreateDevice(IID_IDirect3DRGBDevice,
//									pBack->m_pSurface, &m_pDirect3DDevice,NULL);
			//MONO
			IDirect3D2* pD3D2;
			IDirect3DDevice2* pDv2;
			IDirectDrawSurface* pDDS1;
			m_pDirect3D->QueryInterface(IID_IDirect3D2,(void**)&pD3D2);
			pBack->m_pSurface->QueryInterface(IID_IDirectDrawSurface,(void**)&pDDS1);
			hr = pD3D2->CreateDevice(IID_IDirect3DRampDevice,pDDS1, &pDv2);
			pDv2->QueryInterface(IID_IDirect3DDevice3,(void**)&m_pDirect3DDevice);
			pDv2->Release();
			pDDS1->Release();
			pD3D2->Release();
		}
	}
	if( hr!=D3D_OK )
		return false;

	return true;
}

static HRESULT WINAPI D3DEnumDeviceCallBack(
	LPGUID lpGuid, LPSTR lpDeviceDescription, LPSTR lpDeviceName, 
	LPD3DDEVICEDESC lpHWDesc, LPD3DDEVICEDESC lpHELDesc, LPVOID lpContext) 
{
	D3DDeviceInfo* pInfo = (D3DDeviceInfo *)lpContext;

	// n[hEFAdlɎwJ[fȂ
	if (lpHWDesc->dcmColorModel & pInfo->cm)
	{
		// Zobt@g邩ǂmF
		if ((lpHWDesc->dwDeviceZBufferBitDepth & DDBD_16) ||
			(lpHWDesc->dwDeviceZBufferBitDepth & DDBD_24) ||
			(lpHWDesc->dwDeviceZBufferBitDepth & DDBD_32))
		{
			// OK, dlL^
			pInfo->ZDepth = lpHWDesc->dwDeviceZBufferBitDepth;
			pInfo->pGuid = lpGuid;
			pInfo->bHard = true;
			return D3DENUMRET_CANCEL;
		}

		return D3DENUMRET_OK;
	}

	// \tgEFAdlɎwJ[fȂ
	if (lpHELDesc->dcmColorModel & pInfo->cm)
	{
		// dlL^
		pInfo->ZDepth = lpHELDesc->dwDeviceZBufferBitDepth;
		pInfo->pGuid = lpGuid;
		pInfo->bHard = false;
	}

	return D3DENUMRET_OK;
}
